# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.map_association import MapAssociation  # noqa: F401,E501


class LocalCodeItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_by': 'str',
        'created_date': 'int',
        'last_modified_by': 'str',
        'last_modified_date': 'int',
        'allowed_groups': 'list[str]',
        'organisation': 'str',
        'id': 'str',
        'code': 'str',
        'source': 'str',
        'localterm': 'str',
        'existing_mapping': 'str',
        'category': 'str',
        'additional_columns': 'dict(str, str)',
        'processed': 'bool',
        'excluded': 'bool',
        'associations': 'list[MapAssociation]',
        'tags': 'list[str]',
        'resultables': 'list[str]',
        'specimens': 'list[str]',
        'specimen': 'bool',
        'request': 'bool'
    }

    attribute_map = {
        'created_by': 'createdBy',
        'created_date': 'createdDate',
        'last_modified_by': 'lastModifiedBy',
        'last_modified_date': 'lastModifiedDate',
        'allowed_groups': 'allowedGroups',
        'organisation': 'organisation',
        'id': 'id',
        'code': 'code',
        'source': 'source',
        'localterm': 'localterm',
        'existing_mapping': 'existingMapping',
        'category': 'category',
        'additional_columns': 'additionalColumns',
        'processed': 'processed',
        'excluded': 'excluded',
        'associations': 'associations',
        'tags': 'tags',
        'resultables': 'resultables',
        'specimens': 'specimens',
        'specimen': 'specimen',
        'request': 'request'
    }

    def __init__(self, created_by=None, created_date=None, last_modified_by=None, last_modified_date=None, allowed_groups=None, organisation=None, id=None, code=None, source=None, localterm=None, existing_mapping=None, category=None, additional_columns=None, processed=None, excluded=None, associations=None, tags=None, resultables=None, specimens=None, specimen=None, request=None):  # noqa: E501
        """LocalCodeItem - a model defined in Swagger"""  # noqa: E501

        self._created_by = None
        self._created_date = None
        self._last_modified_by = None
        self._last_modified_date = None
        self._allowed_groups = None
        self._organisation = None
        self._id = None
        self._code = None
        self._source = None
        self._localterm = None
        self._existing_mapping = None
        self._category = None
        self._additional_columns = None
        self._processed = None
        self._excluded = None
        self._associations = None
        self._tags = None
        self._resultables = None
        self._specimens = None
        self._specimen = None
        self._request = None
        self.discriminator = None

        if created_by is not None:
            self.created_by = created_by
        if created_date is not None:
            self.created_date = created_date
        if last_modified_by is not None:
            self.last_modified_by = last_modified_by
        if last_modified_date is not None:
            self.last_modified_date = last_modified_date
        if allowed_groups is not None:
            self.allowed_groups = allowed_groups
        if organisation is not None:
            self.organisation = organisation
        if id is not None:
            self.id = id
        if code is not None:
            self.code = code
        if source is not None:
            self.source = source
        if localterm is not None:
            self.localterm = localterm
        if existing_mapping is not None:
            self.existing_mapping = existing_mapping
        if category is not None:
            self.category = category
        if additional_columns is not None:
            self.additional_columns = additional_columns
        if processed is not None:
            self.processed = processed
        if excluded is not None:
            self.excluded = excluded
        if associations is not None:
            self.associations = associations
        if tags is not None:
            self.tags = tags
        if resultables is not None:
            self.resultables = resultables
        if specimens is not None:
            self.specimens = specimens
        if specimen is not None:
            self.specimen = specimen
        if request is not None:
            self.request = request

    @property
    def created_by(self):
        """Gets the created_by of this LocalCodeItem.  # noqa: E501


        :return: The created_by of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this LocalCodeItem.


        :param created_by: The created_by of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def created_date(self):
        """Gets the created_date of this LocalCodeItem.  # noqa: E501


        :return: The created_date of this LocalCodeItem.  # noqa: E501
        :rtype: int
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date):
        """Sets the created_date of this LocalCodeItem.


        :param created_date: The created_date of this LocalCodeItem.  # noqa: E501
        :type: int
        """

        self._created_date = created_date

    @property
    def last_modified_by(self):
        """Gets the last_modified_by of this LocalCodeItem.  # noqa: E501


        :return: The last_modified_by of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._last_modified_by

    @last_modified_by.setter
    def last_modified_by(self, last_modified_by):
        """Sets the last_modified_by of this LocalCodeItem.


        :param last_modified_by: The last_modified_by of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._last_modified_by = last_modified_by

    @property
    def last_modified_date(self):
        """Gets the last_modified_date of this LocalCodeItem.  # noqa: E501


        :return: The last_modified_date of this LocalCodeItem.  # noqa: E501
        :rtype: int
        """
        return self._last_modified_date

    @last_modified_date.setter
    def last_modified_date(self, last_modified_date):
        """Sets the last_modified_date of this LocalCodeItem.


        :param last_modified_date: The last_modified_date of this LocalCodeItem.  # noqa: E501
        :type: int
        """

        self._last_modified_date = last_modified_date

    @property
    def allowed_groups(self):
        """Gets the allowed_groups of this LocalCodeItem.  # noqa: E501


        :return: The allowed_groups of this LocalCodeItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_groups

    @allowed_groups.setter
    def allowed_groups(self, allowed_groups):
        """Sets the allowed_groups of this LocalCodeItem.


        :param allowed_groups: The allowed_groups of this LocalCodeItem.  # noqa: E501
        :type: list[str]
        """

        self._allowed_groups = allowed_groups

    @property
    def organisation(self):
        """Gets the organisation of this LocalCodeItem.  # noqa: E501


        :return: The organisation of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._organisation

    @organisation.setter
    def organisation(self, organisation):
        """Sets the organisation of this LocalCodeItem.


        :param organisation: The organisation of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._organisation = organisation

    @property
    def id(self):
        """Gets the id of this LocalCodeItem.  # noqa: E501


        :return: The id of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LocalCodeItem.


        :param id: The id of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def code(self):
        """Gets the code of this LocalCodeItem.  # noqa: E501


        :return: The code of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this LocalCodeItem.


        :param code: The code of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def source(self):
        """Gets the source of this LocalCodeItem.  # noqa: E501


        :return: The source of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this LocalCodeItem.


        :param source: The source of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def localterm(self):
        """Gets the localterm of this LocalCodeItem.  # noqa: E501


        :return: The localterm of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._localterm

    @localterm.setter
    def localterm(self, localterm):
        """Sets the localterm of this LocalCodeItem.


        :param localterm: The localterm of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._localterm = localterm

    @property
    def existing_mapping(self):
        """Gets the existing_mapping of this LocalCodeItem.  # noqa: E501


        :return: The existing_mapping of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._existing_mapping

    @existing_mapping.setter
    def existing_mapping(self, existing_mapping):
        """Sets the existing_mapping of this LocalCodeItem.


        :param existing_mapping: The existing_mapping of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._existing_mapping = existing_mapping

    @property
    def category(self):
        """Gets the category of this LocalCodeItem.  # noqa: E501


        :return: The category of this LocalCodeItem.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this LocalCodeItem.


        :param category: The category of this LocalCodeItem.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def additional_columns(self):
        """Gets the additional_columns of this LocalCodeItem.  # noqa: E501


        :return: The additional_columns of this LocalCodeItem.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._additional_columns

    @additional_columns.setter
    def additional_columns(self, additional_columns):
        """Sets the additional_columns of this LocalCodeItem.


        :param additional_columns: The additional_columns of this LocalCodeItem.  # noqa: E501
        :type: dict(str, str)
        """

        self._additional_columns = additional_columns

    @property
    def processed(self):
        """Gets the processed of this LocalCodeItem.  # noqa: E501


        :return: The processed of this LocalCodeItem.  # noqa: E501
        :rtype: bool
        """
        return self._processed

    @processed.setter
    def processed(self, processed):
        """Sets the processed of this LocalCodeItem.


        :param processed: The processed of this LocalCodeItem.  # noqa: E501
        :type: bool
        """

        self._processed = processed

    @property
    def excluded(self):
        """Gets the excluded of this LocalCodeItem.  # noqa: E501


        :return: The excluded of this LocalCodeItem.  # noqa: E501
        :rtype: bool
        """
        return self._excluded

    @excluded.setter
    def excluded(self, excluded):
        """Sets the excluded of this LocalCodeItem.


        :param excluded: The excluded of this LocalCodeItem.  # noqa: E501
        :type: bool
        """

        self._excluded = excluded

    @property
    def associations(self):
        """Gets the associations of this LocalCodeItem.  # noqa: E501


        :return: The associations of this LocalCodeItem.  # noqa: E501
        :rtype: list[MapAssociation]
        """
        return self._associations

    @associations.setter
    def associations(self, associations):
        """Sets the associations of this LocalCodeItem.


        :param associations: The associations of this LocalCodeItem.  # noqa: E501
        :type: list[MapAssociation]
        """

        self._associations = associations

    @property
    def tags(self):
        """Gets the tags of this LocalCodeItem.  # noqa: E501


        :return: The tags of this LocalCodeItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this LocalCodeItem.


        :param tags: The tags of this LocalCodeItem.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def resultables(self):
        """Gets the resultables of this LocalCodeItem.  # noqa: E501


        :return: The resultables of this LocalCodeItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._resultables

    @resultables.setter
    def resultables(self, resultables):
        """Sets the resultables of this LocalCodeItem.


        :param resultables: The resultables of this LocalCodeItem.  # noqa: E501
        :type: list[str]
        """

        self._resultables = resultables

    @property
    def specimens(self):
        """Gets the specimens of this LocalCodeItem.  # noqa: E501


        :return: The specimens of this LocalCodeItem.  # noqa: E501
        :rtype: list[str]
        """
        return self._specimens

    @specimens.setter
    def specimens(self, specimens):
        """Sets the specimens of this LocalCodeItem.


        :param specimens: The specimens of this LocalCodeItem.  # noqa: E501
        :type: list[str]
        """

        self._specimens = specimens

    @property
    def specimen(self):
        """Gets the specimen of this LocalCodeItem.  # noqa: E501


        :return: The specimen of this LocalCodeItem.  # noqa: E501
        :rtype: bool
        """
        return self._specimen

    @specimen.setter
    def specimen(self, specimen):
        """Sets the specimen of this LocalCodeItem.


        :param specimen: The specimen of this LocalCodeItem.  # noqa: E501
        :type: bool
        """

        self._specimen = specimen

    @property
    def request(self):
        """Gets the request of this LocalCodeItem.  # noqa: E501


        :return: The request of this LocalCodeItem.  # noqa: E501
        :rtype: bool
        """
        return self._request

    @request.setter
    def request(self, request):
        """Sets the request of this LocalCodeItem.


        :param request: The request of this LocalCodeItem.  # noqa: E501
        :type: bool
        """

        self._request = request

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LocalCodeItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
